class Purescript < Formula
  desc "Strongly typed programming language that compiles to JavaScript"
  homepage "https://www.purescript.org/"
  # NOTE: If the build fails due to dependency resolution, do not report issue
  # upstream as we modify upstream's constraints in order to use a newer GHC.
  url "https://hackage.haskell.org/package/purescript-0.15.15/purescript-0.15.15.tar.gz"
  sha256 "9c4a23ea47ff09adc34e260610beabd940ec5c15088234cf120e8660dd220e67"
  license "BSD-3-Clause"
  head "https://github.com/purescript/purescript.git", branch: "master"

  depends_on "cabal-install" => :build
  depends_on "ghc@9.6" => :build

  uses_from_macos "ncurses"
  uses_from_macos "zlib"

  def install
    # Minimal set of dependencies that need to be unbound to build with newer GHC
    allow_newer_deps = %w[
      aeson
      base
      memory
      template-haskell
    ]

    system "cabal", "v2-update"
    system "cabal", "v2-install", "--allow-newer=#{allow_newer_deps.join(",")}", *std_cabal_v2_args
  end

  test do
    test_module_path = testpath/"Test.purs"
    test_target_path = testpath/"test-module.js"
    test_module_path.write <<~EOS
      module Test where

      main :: Int
      main = 1
    EOS
    system bin/"purs", "compile", test_module_path, "-o", test_target_path
    assert_predicate test_target_path, :exist?
  end
end
